#Licence: GPLv2.0
#Copyright Jonathan Roadley-Battin 18/09/05

import sys,os
from comp import *
from comp_diode import *
from comp_DeSat import *


import pygtk
if sys.platform == 'win32':
	os.environ['PATH'] += ";gtk/lib;gtk/bin"
else:
	pygtk.require('2.0')
import gtk
import gobject
import gtk.glade




Var = {"label_HtL":False,"label_LtH":False,"input_HtL":False,"input_LtH":False,
"input_Rfb":True,"result_Rfb":False,"label_Rfb":True,
"result_LtH":True,"result_HtL":True,"label_result_HtL":True,"label_result_LtH":True}

#create the compatator instance
CC = comp()





class appgui:
	def __init__(self):
		gladefile="GUI.glade"
		windowname="TESTING"  
		self.ref = False
		self.calc = True
		self.wTree=gtk.glade.XML (gladefile,windowname)
		
		dic = {"on_quit_button_clicked" : self.quit_clicked, 
		"on_select_type_changed" : self.selection_change,
		"on_option_hyster_group_changed" : self.calc_change,
		"on_option_ref_changed" : self.ref_changed,
		"on_changed" : self.var_changed,
		"on_window_destroy" : (gtk.main_quit)}
		
		self.wTree.signal_autoconnect (dic)
		return


#####CALLLBACKS
	def quit_clicked(self,widget):
		gtk.main_quit()
		return
	
	def selection_change(self, widget):
		text = widget.get_active_text()
		print text
		return
	
	def calc_change(self,widget):
		self.calc = not(widget.get_active())
		RES,VOLTS = CC.pack_variables(self)
		if self.calc:
			for x in Var.keys():self.wTree.get_widget(x).set_property('visible', Var[x])
			self.wTree.get_widget("result_HtL").set_text(CC.calc_hyster(RES,VOLTS,self.ref)[0])
			self.wTree.get_widget("result_LtH").set_text(CC.calc_hyster(RES,VOLTS,self.ref)[1])

		else:
			for x in Var.keys():self.wTree.get_widget(x).set_property('visible', not(Var[x]))
			self.wTree.get_widget("result_Rfb").set_text(str(CC.calc_fb(RES,VOLTS,self.ref)))
		


		return
	
	def ref_changed(self,widget):
		self.ref = not(widget.get_active())
		RES,VOLTS = CC.pack_variables(self)
		if self.calc:
			self.wTree.get_widget("result_HtL").set_text(CC.calc_hyster(RES,VOLTS,self.ref)[0])
			self.wTree.get_widget("result_LtH").set_text(CC.calc_hyster(RES,VOLTS,self.ref)[1])			
		else:
			self.wTree.get_widget("result_Rfb").set_text(str(CC.calc_fb(RES,VOLTS,self.ref)))
		return
	
	def var_changed(self,widget):
		RES,VOLTS = CC.pack_variables(self)
		if self.calc:
			self.wTree.get_widget("result_HtL").set_text(CC.calc_hyster(RES,VOLTS,self.ref)[0])
			self.wTree.get_widget("result_LtH").set_text(CC.calc_hyster(RES,VOLTS,self.ref)[1])			
		else:
			self.wTree.get_widget("result_Rfb").set_text(str(CC.calc_fb(RES,VOLTS,self.ref)))
		return

		return

	



if __name__ == '__main__':
	app=appgui()
	gtk.main()
