#Licence: GPLv2.0
#Copyright Jonathan Roadley-Battin 18/09/05

from low_level import *

###############################
# the class "comp" for the standard comparator
#takes in three arguements 
#RES = [Rup,Rin,Rfb] for hyster calc or [Rup,Rin] for Feedback calc
#VOLTS = [Vref,Vup] for hyster calc or [Vref,Vup,VHtL,VLtH] for Feedback calc
#ref = True,False for ref on -ve pin (True)
#
#




class comp:
	def __init__(self):
		self.comp = "comp"
		return
############################################
	def calc_hyster(self,RES,VOLTS,ref):
		t = [0,0]
		Rup,Rin,Rfb = map(float,RES)
		Vref,Vup = map(float,VOLTS)
		RRhl = Rin/(Rin+Rfb+Rup)
		RRlh = (Rin + Rfb)/Rfb
		if ref:
			HighToLow = (Vup - Vref)*RRhl + Vref
			LowToHigh = Vref*(1/RRlh)
		else:		
			HighToLow = (Vref - (Vup*RRhl))/(1- RRhl)
			LowToHigh = Vref*RRlh
		t[0] = "%0.2f" % HighToLow
		t[1] = "%0.2f" % LowToHigh
		return t
#######################################################	
	def calc_fb(self,RES,VOLTS,ref):
		Rup,Rin = map(float,RES)
		Vref,Vup,V1,V2 = map(float,VOLTS)
		if V1==V2: return "no solution"
		
		if ref:
			a = V1 - V2
			b = 2*V1*Rin - 2*V2*Rin + V1*Rup - V2*Rup -Rin*Vup
			c = V1*Rin*Rup - V2*Rin*Rup +V1*Rin*Rin - V2*Rin*Rin - Rin*Rup*Vref -Rin*Rin*Vup
		else:
			a = V1 - V2
			b = Vup*Rin + V1*(Rin+Rup) - V2*(Rin+Rup)
			c = Vup*Rin*Rin -V1*Rin*Rin + V1*Rin*(Rin+Rup)			
		
	
		Feedback = quadratic(a,b,c)
		if Feedback == "no solution":return "no solution"
		elif Feedback[0] * Feedback[1] > 0:	return "no solution"
		elif Feedback[0] < 0: return res_print(Feedback[1])
		else: return res_print(Feedback[0])



	
	def pack_variables(self,wself):
		f = lambda name: wself.wTree.get_widget(name).get_value()
		RES = [f("input_Rup"),f("input_Rin"),]
		VOLTS = [f("input_Vref"),f("input_Vup"),]
		if wself.calc:
			RES.append(f("input_Rfb"))
		else:
			VOLTS.append(f("input_HtL"))
			VOLTS.append(f("input_LtH"))
		return RES, VOLTS
	
	
#################################################################
	
