#Licence: GPLv2.0
#Copyright Jonathan Roadley-Battin 18/09/05

from low_level import *

###############################
# the class "comp_DeSat" for the DeSat comparator
#takes in three arguements 
#RES = [Rup,Rin,R1,Rfb,R2] for hyster calc or [Rup,Rin,R1] for Feedback calc
#VOLTS = [Vref,Vup,Vd,Vdd] for hyster calc or [Vref,Vup,Vd,Vdd,VHtL,VLtH] for Feedback calc
#ref = True,False for ref on -ve pin (True)
#
#




class comp_desat:
	def __init__(self):
		self.comp = "desat"
		return
############################################
	def calc_hyster(self,RES,VOLTS):
		Rup,Rin,R1,Rfb,R2 = map(float,RES)
		Vref,Vup,Vd,Vdd = map(float,VOLTS)

		HighToLow = (R1*Vref - R2*Vcc - R1*Vdd + R2*Vref)/R1
		LowToHigh = Vref - Vdd - (R2*Vcc/R1) - (R2*Vd/Rfb) + (R2*Vref/R1) + (R2*Vref/Rfb)
		
		return HighToLow,LowToHigh
#######################################################	
	def calc_fb(self,RES,VOLTS,ref):
		Rup,Rin,R1 = map(float,RES)
		Vref,Vup,Vd,Vdd,V1,V2 = map(float,VOLTS)
		
		R2 = (R1*Vref - R1*V1 - R1*Vdd)/(Vcc-Vref)

		tmp1 = R1*R2*Vref - R1*R2*Vd
		tmp2 = R2*Vcc+R1*Vdd+R1*V2-R1*Vref-R2*Vref
		Feedback = tmp1/tmp2
		
		return res_print(R2),res_print(Feedback)
#################################################################


	def pack_variables(self,wself):
		f = lambda name: wself.wTree.get_widget(name).get_value()
		RES = [f("input_Rup"),f("input_Rin"),f("input_R1")]
		VOLTS = [f("input_Vref"),f("input_Vup"),f("input_Vd"),f("input_Vdd")]
		if wself.wTree.get_widget("option_hyster").get_active():
			RES.append(f("input_Rfb"))
			RES.append(f("input_R2"))
		else:
			VOLTS.append(f("input_HtL"))
			VOLTS.append(f("input_LtH"))
		return RES, VOLTS
