#Licence: GPLv2.0
#Copyright Jonathan Roadley-Battin 18/09/05

from low_level import *

###############################
# the class "comp-diode" for the diode-FB comparator
#takes in three arguements 
#RES = [Rup,Rin,Rfb] for hyster calc or [Rup,Rin] for Feedback calc
#VOLTS = [Vref,Vup,Vd] for hyster calc or [Vref,Vup,Vd,VHtL,VLtH] for Feedback calc
#ref = True,False for ref on -ve pin (False)
#
#




class comp_diode:
	def __init__(self):
		self.comp = "diode"
		return
############################################
	def calc_hyster(self,RES,VOLTS,ref):
		t = [0,0]
		Rup,Rin,Rfb = map(float,RES)
		Vref,Vup,Vd = map(float,VOLTS)

				
		if ref:
			if Vref < Vup+Vd: HighToLow = Vref
			else: HighToLow = (Rfb*Vref - Vd*Rup - Rfb*Vup -Rup*Vup -  Vd*Rfb + Rup*Vref)/(Rfb+Rin+Rup) +Vd+Vup
			LowToHigh = (Vref - Vd)*(Rfb/(Rfb+Rin)) + Vd
		else:		
			if Vref < Vup+Vd: HighToLow = Vref
			else: HighToLow = (Rfb*Vref - Rin*Vup-Vd*Rin+Rin*Vref+Rup*Vref)/(Rfb+Rup)
			LowToHigh = Vd + ( (Rfb+Rin)*(Vref-Vd)/Rfb)
	
		t[0] = "%0.2f" % HighToLow
		t[1] = "%0.2f" % LowToHigh
		return t
#######################################################	
	def calc_fb(self,RES,VOLTS,ref):
		Rup,Rin = map(float,RES)
		Vref,Vup,Vd,V1,V2 = map(float,VOLTS)
		if V1==V2: return "no solution"
		
		if ref:
			if Vref < Vup+Vd:
				Feedback = (V1*Rin - V2*Rin + Vd*Rin - Rin*Vref)/(V2-V1)
				if V2-V1 < 0: return "no solution"
				return res_print(Feedback)
			else:
				a = V1 -V2
				b = 2*V1*Rin - 2*V2*Rin + V1*Rup - V2*Rup - Rin*Vup
				c = V1*Rin*Rup -V2*Rin*Rup + Vd*Rin*Rup - Rin*Rup*Vref + V1*Rin*Rin - V2*Rin*Rin -Rin*Rin*Vup
				Feedback=quadratic(a,b,c)
				if Feedback == "no solution": return "no solution"
				elif Feedback[0] * Feedback[1] > 0: return "no solution:"
				elif Feedback[0] < 0: return res_print(Feedback[1])
				else: return res_print(Feedback[0])	
			
		else:
			if Vref < Vup+Vd: 
				if V2-V1 < 0: return "no solution"
				Feedback = (Rin*Vref - Vd*Rin)/(V2-V1)
				return res_print(Feedback)
			else:
				a = V1 - V2
				b = V1*Rup - V2*Rup +Rin*Vup
				c = Rin*Rup*Vref - Vd*Rin*Rup
				Feedback = quadratic(a,b,c)
				if Feedback == "no solution": return "no solution"
				elif Feedback[0] * Feedback[1] > 0: return "no solution:"
				elif Feedback[0] < 0: return res_print(Feedback[1])
				else: return res_print(Feedback[0])
			
			
			
	def pack_variables(self,wself):
		f = lambda name: wself.wTree.get_widget(name).get_value()
		RES = [f("input_Rup_D"),f("input_Rin_D")]
		VOLTS = [f("input_Vref_D"),f("input_Vup_D"),f("input_Vd_D")]
		if wself.wTree.get_widget("option_hyster_D").get_active():
			RES.append(f("input_Rfb_D"))
		else:
			VOLTS.append(f("input_HtL_D"))
			VOLTS.append(f("input_LtH_D"))
		return RES, VOLTS		
	
	
#################################################################

