#Licence: GPLv2.0
#Copyright Jonathan Roadley-Battin 18/09/05

import math

def quadratic(a,b,c):
	feedback = []
	tmp = math.sqrt( b*b - 4*a*c)
	feedback.append( (-1*b + tmp)/(2*a) )
	feedback.append( (-1*b - tmp)/(2*a) )
	return feedback

def res_print(Feedback):
	if Feedback > 1e6: ext = [1e6,"M Ohm"]
	elif Feedback > 1e3: ext = [1e3,"k Ohm"]
	elif Feedback >1: ext = [1," Ohm"]
	elif Feedback > 1e-3: ext = [1e-3,"m Ohm"]
	else: ext = [1e-6,"u Ohm"]

	#print"Feedback is: %.1f%s" % (Feedback/ext[0] , ext[1])
	return "%.1f%s" % (Feedback/ext[0] , ext[1])

R1 = 30e3
R2 = 4.2e3
Rfb = 30e3


Vref = 6
Vup = 5
Vcc = 15
Vd = 0.7
Vdd = 0.7+0.7



	
########################################################
# Reference on -ve pin, signal via resistor to +ve pin #
########################################################
HighToLow = (R1*Vref - R2*Vcc - R1*Vdd + R2*Vref)/R1
LowToHigh = Vref - Vdd - (R2*Vcc/R1) - (R2*Vd/Rfb) + (R2*Vref/R1) + (R2*Vref/Rfb)

print "%.2f %.2f" % (HighToLow , LowToHigh)
########################
# Hysteresis Calc      #
########################
V1 = HighToLow
V2 = LowToHigh

R2 = (R1*Vref - R1*V1 - R1*Vdd)/(Vcc-Vref)
print "Feed-in resistor is: %s" % res_print(R2)

tmp1 = R1*R2*Vref - R1*R2*Vd
tmp2 = R2*Vcc+R1*Vdd+R1*V2-R1*Vref-R2*Vref
Feedback = tmp1/tmp2


print "Feedback resistor is: %s" % res_print(Feedback)







