#Licence: GPLv2.0
#Copyright Jonathan Roadley-Battin 18/09/05

import math

def quadratic(a,b,c):
	feedback = []
	tmp = math.sqrt( b*b - 4*a*c)
	feedback.append( (-1*b + tmp)/(2*a) )
	feedback.append( (-1*b - tmp)/(2*a) )
	return feedback

def res_print(Feedback):
	if Feedback > 1e6: ext = [1e6,"M Ohm"]
	elif Feedback > 1e3: ext = [1e3,"k Ohm"]
	elif Feedback >1: ext = [1," Ohm"]
	elif Feedback > 1e-3: ext = [1e-3,"m Ohm"]
	else: ext = [1e-6,"u Ohm"]

	#print"Feedback is: %.1f%s" % (Feedback/ext[0] , ext[1])
	return "%.1f%s" % (Feedback/ext[0] , ext[1])



Rup = 10e3
Rfb = 30e3
Rin = 10e3

Vref = 6
Vup = 5
Vd = 0.7


########################################################
# Reference on -ve pin, signal via resistor to +ve pin #
########################################################
if Vref < Vup+Vd: HighToLow = Vref
else: HighToLow = (Rfb*Vref - Rin*Vup-Vd*Rin+Rin*Vref+Rup*Vref)/(Rfb+Rup)
	
LowToHigh = Vd + ( (Rfb+Rin)*(Vref-Vd)/Rfb)

print "%.2f %.2f" % (HighToLow , LowToHigh)


########################
# Hysteresis Calc      # TODO:
########################
V1 = HighToLow
V2 = LowToHigh

a = V1 - V2
b = V1*Rup - V2*Rup +Rin*Vup
c = Rin*Rup*Vref - Vd*Rin*Rup

if Vref < Vup+Vd: 
	Feedback = (Rin*Vref - Vd*Rin)/(V2-V1)
	print "Feedback resistor is: %s" % res_print(Feedback)
else: 
	Feedback = quadratic(a,b,c)
	if Feedback[0] * Feedback[1] > 0: print "no solution: change reference if possible"
	elif Feedback[0] < 0: print "Feedback resistor is: %s" % res_print(Feedback[1])
	else: print "Feedback resistor is: %s" % res_print(Feedback[0])
	
	

print "#####################################"
###########################################################
# Reference on +ve pin via resistor, signal in to -ve pin #
###########################################################
if Vref < Vup+Vd: HighToLow = Vref
else: HighToLow = (Rfb*Vref - Vd*Rup - Rfb*Vup -Rup*Vup -  Vd*Rfb + Rup*Vref)/(Rfb+Rin+Rup) +Vd+Vup

LowToHigh = (Vref - Vd)*(Rfb/(Rfb+Rin)) + Vd

print "%.2f %.2f" % (HighToLow , LowToHigh)


########################
# Hysteresis Calc      # This needs to be fixed
########################
V1 = HighToLow
V2 = LowToHigh

if Vref < Vup+Vd:
	Feedback = (V1*Rin - V2*Rin + Vd*Rin - Rin*Vref)/(V2-V1)
	print "Feedback resistor is: %s" % res_print(Feedback)
else:
	a = V1 -V2
	b = 2*V1*Rin - 2*V2*Rin + V1*Rup - V2*Rup - Rin*Vup
	c = V1*Rin*Rup -V2*Rin*Rup + Vd*Rin*Rup - Rin*Rup*Vref + V1*Rin*Rin - V2*Rin*Rin -Rin*Rin*Vup
	
	Feedback=quadratic(a,b,c)
	if Feedback[0] * Feedback[1] > 0: print "no solution: change reference if possible"
	elif Feedback[0] < 0: print "Feedback resistor is: %s" % res_print(Feedback[1])
	else: print "Feedback resistor is: %s" % res_print(Feedback[0])

